/*
 * console fucker
 * by glen@alkohol.ee, rebane@alkohol.ee
 *
 * Licensed under GPL
 * http://glen.alkohol.ee/cf/
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <termios.h>
#include <linux/kd.h>
#include <ncurses/curses.h>
#include <errno.h>
#include <string.h>
#include <ctype.h>
#include "keys.h"

static char knbuf[512];
static char snbuf[512];
static char escs[3] = {0, 0, 0};

static int colour_map[] = {
	COLOR_BLACK, COLOR_BLUE, COLOR_GREEN, COLOR_CYAN, COLOR_RED, COLOR_MAGENTA, COLOR_YELLOW, COLOR_WHITE
};

// some macro to show better ACS chars
#define add_remap(c, ch, acs, rest) (c == ch ? acs : rest)

#define remap_acs(c) ( \
	add_remap(c, 0xc6, ACS_ULCORNER,    /* upper left corner */ \
	add_remap(c, 0xc3, ACS_LLCORNER,    /* lower left corner */ \
	add_remap(c, 0xcc, ACS_URCORNER,    /* upper right corner */ \
	add_remap(c, 0xc9, ACS_LRCORNER,    /* lower right corner */ \
	add_remap(c, 0xc7, ACS_LTEE,        /* tee pointing right */ \
	add_remap(c, 0xcd, ACS_RTEE,        /* tee pointing left */ \
	add_remap(c, 0xcb, ACS_BTEE,        /* tee pointing up */ \
	add_remap(c, 0xce, ACS_TTEE,        /* tee pointing down */ \
	add_remap(c, 0xca, ACS_HLINE,       /* horizontal line */ \
	add_remap(c, 0xc5, ACS_VLINE,       /* vertical line */ \
	add_remap(c, 0xcf, ACS_PLUS,        /* CF CF CF !!! */ \
	c \
	))))))))))) /* shit ;P */ \
)

// the Fx key that exits
static int EXIT_Fx = 12;

void exit_handler(void)
{
	endwin();
}

static void usage(const char *self) {
	fprintf(stderr, "Linux Console fucker v%s by Rebane & glen\n", VERSION);

	fprintf(stderr, "Usage:\n");
	fprintf(stderr,"\tcf [OPTIONS] [escape characters]]\n");
	fprintf(stderr,"\tcdump <console>\n");

	fprintf(stderr, "\ncf options:\n");
	fprintf(stderr,	"\t-c <NUMBER> - console NUMBER to capture\n");
	fprintf(stderr,	"\t-d - dump captured screen text to stdout with ansi escapes and exit\n");
	fprintf(stderr,	"\t-x <Fx> - an Fx key that exits cf; default F12\n");
	fprintf(stderr, "\nExample: cf -c <vt nr.> [escape characters]\n");
	fprintf(stderr, "\tDefault escape characters = control-c, control-z, control-l\n");
	fprintf(stderr, "\nNote:\n");
	fprintf(stderr, "\tIf program is called 'cdump' then program defaults to 'cf -d -c'.\n");
	fprintf(stderr, "\tTTY number 0 refers to current active console.\n");
}

static int is_number(char *p) {
char *s = p;

	while (*s) {
		if (!isdigit(*s)) {
			return 0;
		}
		s++;
	}
	return 1;
}

static void dumpscreen(int fd) {
unsigned char x, y;
unsigned char sx, sy;
unsigned char attr, ch;
int bg, fg, bold;
int obg, ofg, obold;

	if (lseek(fd, 0, SEEK_SET) == -1) {
		perror("lseek");
		exit(1);
	}

	read(fd, &sy, 1);
	read(fd, &sx, 1);

	read(fd, &y, 1);
	read(fd, &x, 1);

	for (y = 0; y < sy; y++) {
		obg = ofg = obold = -1;
		for (x = 0; x < sx; x++) {
			read(fd, &ch, 1);
			read(fd, &attr, 1);

			bg = colour_map[(attr >> 4) & 7];
			fg = colour_map[attr & 7];
			bold = attr >> 3 & 1;

			if (bold && bold != obold)
				fprintf(stdout, "\033[1m");

			if (!bold && bold != obold)
				fprintf(stdout, "\033[0m");

			if (fg != ofg)
				fprintf(stdout, "\033[3%dm", fg);

			if (bg != obg)
				fprintf(stdout, "\033[4%dm", bg);

			fprintf(stdout, "%c", ch);
			obg = bg;
			ofg = fg;
			obold = bold;
		}
		fprintf(stdout, "\n");
	}
}

static int dump = 0;

int main(int argc, char *argv[]) {
int kfd, sfd, xz, yz;
unsigned char x, y, xc, yc, i, j, z;
char s;
char *kn = NULL, *sn = NULL;
int colours = 0;
unsigned char attr;
chtype ch;

	if (strcmp(argv[0], "cdump") == 0) {
		int tty = 0;
		if (argc > 1) {
			optarg = argv[1];
		} else {
			optarg = "0";
		}

		if (!is_number(optarg)) {
			fprintf(stderr, "%s: argument '%s' is not numeric\n", argv[0], optarg);
			return(1);
		}

		tty = atoi(optarg);
		if (tty) {
			sprintf(snbuf, "/dev/vcsa%d", tty);
		} else {
			sprintf(snbuf, "/dev/vcsa");
		}
		if ((sfd = open(snbuf, O_RDONLY)) == -1) {
			// try devfs
			sprintf(snbuf, "/dev/vcc/a%s", (tty ? optarg : ""));
			sfd = open(snbuf, O_RDONLY);
			if (sfd == -1) {
				fprintf(stderr, "%s: can't open %s: %s\n", argv[0], snbuf, strerror(errno));
				return(1);
			}
		}
		dumpscreen(sfd);
		close(sfd);
		exit(0);
	}
	if (argc < 3) {
		usage(argv[0]);
		return(1);
	}

	while (1) {
		char c = getopt(argc, argv, "dc:x:");
		if (c == -1) break;
		switch(c) {
		case 'd':
			dump = 1;
			break;

		case 'x': {
			int x = atoi(optarg);

			if (x < 1 || x > 12) {
				fprintf(stderr, "%s: `%s' is not number between 1..12\n", argv[0], optarg);
				usage(argv[0]);
				return(1);
			}
			EXIT_Fx = x;
			break;
		}

		case 'c':
		    if (!is_number(optarg)) {
			    fprintf(stderr, "%s: argument '%s' is not numeric\n", argv[0], optarg);
				return(1);
		    }
			sprintf(snbuf, "/dev/vcsa%s", optarg);
			if ((sfd = open(snbuf, O_RDONLY)) == -1) {
				sprintf(snbuf, "/dev/vcc/a%s", optarg);
			} else {
				close(sfd);
			}
			sprintf(knbuf, "/dev/tty%s", optarg);
			if ((kfd = open(knbuf, O_RDONLY)) == -1) {
				sprintf(knbuf, "/dev/vc/%s", optarg);
			} else {
				close(kfd);
			}
			sn = snbuf;
			kn = knbuf;
			break;
		default:
			printf("?? getopt returned character code 0%o ??\n", c);
		}
	}
	if (optind < argc) {
		strncpy(escs, argv[optind], 3);
	}

	if (!sn || !kn) {
		usage(argv[0]);
		return(1);
	}
	sfd = open(sn, O_RDONLY);
	if (sfd == -1) {
		fprintf(stderr, "%s: can't open %s: %s\n", argv[0], sn, strerror(errno));
		return(1);
	}
	kfd = open(kn, O_RDONLY);
	if (kfd == -1) {
		close(sfd);
		fprintf(stderr, "%s: can't open %s: %s\n", argv[0], kn, strerror(errno));
		return(1);
	}

	if (dump) {
		dumpscreen(sfd);
		close(sfd);
		exit(0);
	}

	initscr();

	// register exit function
	atexit(exit_handler);

	xz = COLS;
	yz = LINES;
	lseek(sfd, 0, SEEK_SET);
	read(sfd, &y, 1);
	read(sfd, &x, 1);
	if ((y > yz) || (x > xz)) {
		close(sfd);
		fprintf(stderr, "%s: can't capture: your screen is smaller than the screen you want to capture.\n", argv[0]);
		fprintf(stderr, "Your screen is %dx%d, you need %dx%d.\n", xz, yz, x, y);
		return(1);
	}

#if 1
	meta(stdscr, TRUE);

	raw();
	nodelay(stdscr, TRUE);
	noecho();
	nonl();

	keypad(stdscr, TRUE);
#else
	// breaks ^c ^\ ...
	cbreak();
	noecho();
	nodelay(stdscr, 1);
#endif

	colours = has_colors();
	if (colours) {
		int bg, fg;

		start_color();
		if (COLORS != 8) {
			fprintf(stderr, "You have %d colours. I'm not prepared for that!!\n", COLORS);
			exit(1);
		}
		for (bg = 0; bg < COLORS; bg++) {
			for (fg = 0; fg < COLORS; fg++) {
				int pair = (bg * COLORS) + fg;
				init_pair(pair, colour_map[fg], colour_map[bg]);
			}
		}
	}

	init_keys();
	while (1) {
		lseek(sfd, 0, SEEK_SET);
		read(sfd, &y, 1);
		read(sfd, &x, 1);
		// this not needed? can you resize console?
		if ((y > yz) || (x > xz)) {
			close(sfd);
			fprintf(stderr, "%s: can't capture: your screen is smaller than the screen you want to capture\n", argv[0]);
			return(1);
		}
		read(sfd, &yc, 1);
		read(sfd, &xc, 1);
		for (i = 0; i < y; i++) {
			for (j = 0; j < x; j++) {
				read(sfd, &z, 1);
				read(sfd, &attr, 1);

				if (colours) {
					int bg = (attr >> 4) & 7;
					int fg = attr & 7;
					int bold = attr >> 3 & 1;

					bkgdset((bold ? A_BOLD : A_NORMAL) | ' ' | COLOR_PAIR(fg + (bg * COLORS)));
				}

				ch = remap_acs(z);
				mvwaddch(stdscr, i, j, ch);
			}
		}
		wmove(stdscr, xc, yc);
		wrefresh(stdscr);
		if ((ch = wgetch(stdscr)) != ERR) {
			char *keystr;
			if (ch == KEY_F(EXIT_Fx)) {
				exit(0);
			}
			if ((keystr = get_keystr(ch))) {
				kfd = open(kn, O_RDONLY);
				do {
					ioctl(kfd, TIOCSTI, keystr);
				} while (*++keystr);
				close(kfd);
				continue;
			}
			if (ch > 255) {
				// make that area red
				bkgdset(A_BOLD | ' ' |
					COLOR_PAIR(COLOR_WHITE + (COLOR_BLUE * COLORS)));

				mvwprintw(stdscr, LINES - 1, 0,
					" Warning: Unknown key: %d %s", ch, keyname(ch));
				wclrtobot(stdscr);
				beep();
				wrefresh(stdscr);
				napms(500); // sleep so he could see the warning
				continue;
			}
			s = ch;
			kfd = open(kn, O_RDONLY);
			if (s == escs[0]) {
				s = 0x03; // ctrl+c
			} else if (s == escs[1]) {
				s = 0x1a;
			} else if (s == escs[2]) {
				s = 0x0c;
			}
			ioctl(kfd, TIOCSTI, &s);
			close(kfd);
		}
	}
	/* You motherfucker! Quand nous y arriverons? */
	close(sfd);
}
